/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package wcs.tools;

import java.util.Iterator;
import org.odmg.DBag;
import org.odmg.Database;
import org.odmg.Implementation;
import org.odmg.ODMGException;
import org.odmg.OQLQuery;
import org.odmg.Transaction;
import rasj.RasImplementation;

/**
 *
 * @author andrei
 */
public class QueryExample
{
    public final String query = "select max_cells(c.0) from rgb as c";

    private String server;
    private String base;
    Implementation myApp = null;
    Database myDb = null;
    Transaction myTa = null;

    public QueryExample(String s, String b)
    {
        this.server = s;
        this.base = b;

        myApp = new RasImplementation(server);
        myDb = myApp.newDatabase();
    }

    public void log(String msg)
    {
        System.err.flush();
        System.out.println("log> " + msg);
        System.out.flush();
    }

    private void init() throws ODMGException
    {
        if (myApp == null)
        {
            myApp = new RasImplementation(server);
        }
        if (myDb == null)
        {
            myDb = myApp.newDatabase();
        }
        log("Opening database...");
        myDb.open(base, Database.OPEN_READ_ONLY);
        log("Beginning new transaction ...");
        myTa = myApp.newTransaction();
        myTa.begin();
    }

    private void finish() throws ODMGException
    {
        log("Commiting transaction ...");
        myTa.commit();
        log("Closing database...");
        myDb.close();
        log("Finished !");
    }

    private void abort() throws ODMGException
    {
        log("Aborting transaction...");
        myTa.abort();
        log("Closing database...");
        myDb.close();
        log("Finished !");
    }

    public void sendQuery() throws ODMGException
    {
        

        init();

        log("Querying for all available collections ...");
        OQLQuery myQu = myApp.newOQLQuery();
        myQu.create(query);

        DBag resultSet = (DBag) myQu.execute();
        if (resultSet != null)
        {
            Iterator iter = resultSet.iterator();
            while (iter.hasNext())
            {
                Byte myByte = (Byte) iter.next();
                System.out.println("*** Result is: " + myByte);
            }
        }

        finish();
    }

    public static void main(String[] args) throws ODMGException
    {
        QueryExample ex = new QueryExample(
                "http://kahlua.eecs.jacobs-university.de:9001", "RASSERVICE");
        ex.sendQuery();
    }
}
